﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using System.Diagnostics;
using System.Reflection;
using System.IO;

namespace MemDataTable_CS
{
    public partial class Form1 : Form
    {
        private DataTable dt1;

        public Form1()
        {
            InitializeComponent();                     
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Set grid's DataSource
            dt1 = DummyDataCreator.GetData(100);
            dt1.TableName = "Band 0";

            dt1.AcceptChanges();
            this.ultraGrid1.DataSource = dt1;

            this.CreateBoldAppearance();
        }
      
        private void btnMakeCellBold_Click(object sender, EventArgs e)
        {
            var activeCell = this.ultraGrid1.ActiveCell;
            if (null != activeCell)
                activeCell.Appearance = this.ultraGrid1.DisplayLayout.Appearances["Bold"];
        }

        private void btnResetBold_Click(object sender, EventArgs e)
        {
            this.ResetBoldAppearance();
            this.CreateBoldAppearance();
        }

        private void ResetBoldAppearance()
        {
            // Reset the bold appearance. This will affect all cells to which this
            // same Appearance instance was applied. 
            var layout = this.ultraGrid1.DisplayLayout;
            var boldAppearance = this.ultraGrid1.DisplayLayout.Appearances["Bold"];
            // You could just reset the Bold state here instead of the entire appearance
            // but since the appearance is being removed and disposed, it makes sense to 
            // clear everything. 
            //boldAppearance.FontData.ResetBold();
            boldAppearance.Reset();

            this.ultraGrid1.DisplayLayout.Appearances.Remove(boldAppearance);
            boldAppearance.Dispose();
        }

        private void CreateBoldAppearance()
        {
            // This approach creates an appearance with a bold font.
            // You can make a cell bold by settin the cell.Appearance to this
            // Appearance object. 
            // Since all of the bold cells are using the same Appearance object
            // any changes to this Appearance object will affect all of the cells. 
            // This means that if you Reset the bold state on this appearance, the cells 
            // will no longer be bold. 
            // Note that one limitation of this approach is that all of the cells have the
            // same appearance. If you set a BackColor, ForeColor, or any other appearance
            // property on any one of these cells, it will apply to all of them. So this approach 
            // will not work if you are applying other appearance settings at the cell level. 
            //
            var boldAppearance = this.ultraGrid1.DisplayLayout.Appearances.Add("Bold");
            boldAppearance.FontData.Bold = DefaultableBoolean.True;
        }
    }
}
